
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Import_jobsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const import_jobs = await db.import_jobs.create(
            {
                id: data.id || undefined,
        
        job_type: data.job_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        started_at: data.started_at
        ||
        null
            ,
            
        finished_at: data.finished_at
        ||
        null
            ,
            
        processed_count: data.processed_count
        ||
        null
            ,
            
        error_count: data.error_count
        ||
        null
            ,
            
        log: data.log
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await import_jobs.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.import_jobs.getTableName(),
                belongsToColumn: 'input_file',
                belongsToId: import_jobs.id,
            },
            data.input_file,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.import_jobs.getTableName(),
                belongsToColumn: 'output_file',
                belongsToId: import_jobs.id,
            },
            data.output_file,
            options,
        );
        

        return import_jobs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const import_jobsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                job_type: item.job_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                started_at: item.started_at
            ||
            null
            ,
            
                finished_at: item.finished_at
            ||
            null
            ,
            
                processed_count: item.processed_count
            ||
            null
            ,
            
                error_count: item.error_count
            ||
            null
            ,
            
                log: item.log
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const import_jobs = await db.import_jobs.bulkCreate(import_jobsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < import_jobs.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.import_jobs.getTableName(),
                    belongsToColumn: 'input_file',
                    belongsToId: import_jobs[i].id,
                },
                data[i].input_file,
                options,
            );
        }
        
        for (let i = 0; i < import_jobs.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.import_jobs.getTableName(),
                    belongsToColumn: 'output_file',
                    belongsToId: import_jobs[i].id,
                },
                data[i].output_file,
                options,
            );
        }
        

        return import_jobs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const import_jobs = await db.import_jobs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.job_type !== undefined) updatePayload.job_type = data.job_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.finished_at !== undefined) updatePayload.finished_at = data.finished_at;
        
        
        if (data.processed_count !== undefined) updatePayload.processed_count = data.processed_count;
        
        
        if (data.error_count !== undefined) updatePayload.error_count = data.error_count;
        
        
        if (data.log !== undefined) updatePayload.log = data.log;
        
        
        updatePayload.updatedById = currentUser.id;

        await import_jobs.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await import_jobs.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.import_jobs.getTableName(),
                belongsToColumn: 'input_file',
                belongsToId: import_jobs.id,
            },
            data.input_file,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.import_jobs.getTableName(),
                belongsToColumn: 'output_file',
                belongsToId: import_jobs.id,
            },
            data.output_file,
            options,
        );
        

        return import_jobs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const import_jobs = await db.import_jobs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of import_jobs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of import_jobs) {
                await record.destroy({transaction});
            }
        });


        return import_jobs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const import_jobs = await db.import_jobs.findByPk(id, options);

        await import_jobs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await import_jobs.destroy({
            transaction
        });

        return import_jobs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const import_jobs = await db.import_jobs.findOne(
            { where },
            { transaction },
        );

        if (!import_jobs) {
            return import_jobs;
        }

        const output = import_jobs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await import_jobs.getOrganization({
            transaction
        });
        
        
        output.input_file = await import_jobs.getInput_file({
            transaction
        });
        
        
        output.output_file = await import_jobs.getOutput_file({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



      {
        model: db.file,
        as: 'input_file',
      },

      {
        model: db.file,
        as: 'output_file',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.log) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'import_jobs',
                        'log',
                        filter.log,
                    ),
                };
            }
            

            
            

            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.finished_atRange) {
                const [start, end] = filter.finished_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    finished_at: {
                    ...where.finished_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    finished_at: {
                    ...where.finished_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.processed_countRange) {
                const [start, end] = filter.processed_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    processed_count: {
                    ...where.processed_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    processed_count: {
                    ...where.processed_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.error_countRange) {
                const [start, end] = filter.error_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    error_count: {
                    ...where.error_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    error_count: {
                    ...where.error_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.job_type) {
                where = {
                    ...where,
                job_type: filter.job_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.import_jobs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'import_jobs',
                        'job_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.import_jobs.findAll({
            attributes: [ 'id', 'job_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['job_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.job_type,
        }));
    }

    
};

